<template>
  <two-pane-layout
    ref="layout"
    :show-right-pane="showSubmissionType"
  >
    <template #left>
      <v-container>
        <route-change-confirmation :next-route="nextRoute" />
        <submission-correction
          :key="currentAssignment.pk"
          :assignment="currentAssignment"
          @feedbackCreated="startWorkOnNextAssignment"
        />
        <submission-tests
          :tests="submission.tests"
          :expand="true"
        />
      </v-container>
    </template>
    <template #right>
      <submission-type
        :key="submissionType.pk"
        v-bind="submissionType"
        :expanded-by-default="{ Description: true, Solution: true }"
      />
    </template>
  </two-pane-layout>
</template>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { Route, NavigationGuard } from 'vue-router'
import SubmissionCorrection from '@/components/submission_notes/SubmissionCorrection.vue'
import SubmissionType from '@/components/submission_type/SubmissionType.vue'
import store from '@/store/store'
import { SubmissionNotes } from '@/store/modules/submission-notes'
import SubmissionTests from '@/components/SubmissionTests.vue'
import { Assignments } from '@/store/modules/assignments'
import RouteChangeConfirmation from '@/components/submission_notes/RouteChangeConfirmation.vue'
import { getters } from '@/store/getters'
import { SubmissionAssignment } from '@/models'
import { UI } from '@/store/modules/ui'
import TwoPaneLayout from '@/components/TwoPaneLayout.vue'

const onRouteEnterOrUpdate: NavigationGuard =  function (to, from, next) {
  Assignments.changeAssignment(to).then(() => {
    if (from === to) {
      return
    }
    next()
  })
}

@Component({
  components: {
    RouteChangeConfirmation,
    SubmissionTests,
    SubmissionType,
    SubmissionCorrection,
    TwoPaneLayout,
  }
})
export default class SubscriptionWorkPage extends Vue {
  $refs!: {
    layout: TwoPaneLayout
  }

  subscriptionActive = false
  nextRoute = () => {}

  get showSubmissionType () {
    return UI.state.showSubmissionType
  }

  get currentAssignment () {
    return Assignments.state.currentAssignment
  }

  get submission () {
    return this.currentAssignment && this.currentAssignment.submission
  }

  get submissionType () {
    if (this.submission && (this.submission as SubmissionAssignment).type) {
      return getters.state.submissionTypes[(this.submission as SubmissionAssignment).type]
    }
  }

  beforeRouteEnter (to: Route, from: Route, next: (to?: any) => void ) {
    onRouteEnterOrUpdate(to, from, next)
  }

  beforeRouteUpdate (this: SubscriptionWorkPage, to: Route, from: Route, next: (to?: any) => void) {
    this.nextRoute = () => {
      onRouteEnterOrUpdate(to, from, next)
    }
  }

  beforeRouteLeave (this: SubscriptionWorkPage, to: Route, from: Route, next: (to?: any) => void) {
    if (to.name === 'correction-ended') {
      next()
    } else {
      this.nextRoute = () => {
        next()
        Assignments.deleteCurrentAssignment()
      }
    }
  }

  startWorkOnNextAssignment () {
    Assignments.createNextAssignment().then(() => {
      Assignments.getAvailableSubmissionCounts()
    }).catch(() => {
      Assignments.SET_CURRENT_ASSIGNMENT(undefined)
      this.$router.replace({name: 'correction-ended'})
    })
  }

  @Watch('currentAssignment')
  onCurrentAssignmentChanged() {
    this.$refs.layout.leftPane().scrollTop = 0
  }
}
</script>
